/* Welcome to the ECU Reader project. This sketch uses the Canbus library.
It requires the CAN-bus shield for the Arduino. This shield contains the MCP2515 CAN controller and the MCP2551 CAN-bus driver.
A connector for an EM406 GPS receiver and an uSDcard holder with 3v level convertor for use in data logging applications.
The output data can be displayed on a serial LCD.

SK Pang Electronics www.skpang.co.uk

v1.0 28-03-10

*/


#include <Canbus.h>

int LED2 = 8; //buzzer
int LED3 = 7; //Car PC Turn-on
unsigned long time;
int buffer[36];
unsigned long timer = millis() ;
unsigned long PDC_timer = timer;


void setup() {
  
  pinMode(LED2, OUTPUT); 
  pinMode(LED3, OUTPUT); 
  digitalWrite(LED2, LOW); //Buzzer off
  Serial.begin(115200);
 // Serial.println("ECU Reader");  /* For debug use */
  
 
  if(Canbus.init(CANSPEED_100))  /* Initialise MCP2515 CAN controller at the specified speed */
  {
  //  Serial.print("CAN Init ok");
  } else
  {
   // Serial.print("Can't init CAN");
  } 
  digitalWrite(LED3, HIGH); // Can Available turn PC on
  delay(2000); 

}
 
 void loop() {
    
  if(Canbus.ecu_req(buffer) == 1)
  {
        // 
        // Watch for remote contol
        // 
        if(buffer[0] == 570)                     
        {
                  if(buffer[3] == 4 )                     
                  {
                  digitalWrite(LED3, LOW);         // Time to shut up shop and turn off the PC
                  }
                  if(buffer[3] == 1 )                     
                  {
                  digitalWrite(LED3, HIGH);         // Turn on the PC
                  }
        }
        
              timer = millis() ;
      
        // 
        // Clear and remove PDC if timer is over 5 seconds
        // 
         if(timer > (PDC_timer+5000))            
         {digitalWrite(LED2, LOW); //Fail safe, No PDC make sure buzzer is off
         }
         
               if(buffer[0] == 450) 
        {

      digitalWrite(LED2, LOW);
      if(buffer[1] <=70){digitalWrite(LED2, HIGH); }
      if(buffer[2] <=70){digitalWrite(LED2, HIGH); }
      if(buffer[3] <=70){digitalWrite(LED2, HIGH); }
      if(buffer[4] <=70){digitalWrite(LED2, HIGH); }
              PDC_timer = timer;
        }
        
        //
        // main write
        //
        
                if(buffer[0] <=255)                     
        {
            Serial.print("0x0");} // write lead character
          else
            {Serial.print("0x");} // write lead character          
        
          
    Serial.print(buffer[0],HEX); // ID
    Serial.print(" ");
    Serial.print(buffer[10]); //Length
    for (int x = 1 ; x <=buffer[10]; x++) // Only write the number of data bytes available
    {
      Serial.print(" ");
      Serial.print(buffer[x]);

    }

    Serial.println(" "); // New line
    
  }
   delay(1); 


}
